/**
 * 
 */
package uoc.tfc.gien;


import java.util.ArrayList;
import java.util.Iterator;



import uoc.tfc.gien.entities.geo.GPSPosition;
import uoc.tfc.gien.entities.geo.GeoObject;
import uoc.tfc.gien.entities.geo.Layer;
import uoc.tfc.gien.entities.geo.SinglePointObject;




import android.app.IntentService;

import android.content.Intent;


/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class TestPuntsCardinalsIntentService extends IntentService {
	
	final String TAG = "RefreshGeofencesIntentService";
	private GlobalApplicationData app;

	
	public TestPuntsCardinalsIntentService() {
		super("GeofenceTransitionsIntentService");
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
		app = (GlobalApplicationData) this.getApplicationContext();
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		app.broadcastMapChanging(getBaseContext(), true);
		ArrayList<Layer> layers = app.getExperience().getMap().getLayers();
		GPSPosition userLocation = app.getLocation();
		double userLatitude = userLocation.getLatitude();
		double userLongitude = userLocation.getLongitude();
		Iterator<Layer> it = layers.iterator();
		Layer l = null;
		SinglePointObject spo;
		while (it.hasNext()) {
			l = it.next();
			Iterator<GeoObject> itg = l.getObjects().iterator();
			GeoObject gObj = null;
			while (itg.hasNext()) {
				gObj = itg.next();
				if (gObj.getType()==GeoObject.Type.SINGLE_POINT) {
					spo = (SinglePointObject)gObj;
					switch (spo.getId()) {
						case 1:
							//punt nord
							spo.getCenter().setLatitude(userLatitude+0.000230);
							spo.getCenter().setLongitude(userLongitude);
							break;
						case 2:
							//punt sud
							spo.getCenter().setLatitude(userLatitude-0.000230);
							spo.getCenter().setLongitude(userLongitude);
							break;
						case 3:
							//punt est
							spo.getCenter().setLatitude(userLatitude);
							spo.getCenter().setLongitude(userLongitude+0.000310);
							break;
						case 4:
							//punt oest
							spo.getCenter().setLatitude(userLatitude);
							spo.getCenter().setLongitude(userLongitude-0.000310);
							break;
					}	
				}
			}
		}
		app.broadcastMapChanging(getBaseContext(), false);
	}

}
