/**
 * 
 */
package uoc.tfc.gien;


import java.util.ArrayList;

import org.json.JSONObject;

import uoc.tfc.gien.entities.geo.Layer;
import uoc.tfc.gien.entities.geo.Map;

import android.app.IntentService;
import android.content.Intent;


/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class UpdateMapIntentService extends IntentService {
	
	final String TAG = "UpdateMapIntentService";
	private GlobalApplicationData app;

	
	public UpdateMapIntentService() {
		super("GeofenceTransitionsIntentService");
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
		app = (GlobalApplicationData) this.getApplicationContext();
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		app.broadcastMapChanging(getBaseContext(), true);
		try {
			JSONObject rootObj = new JSONObject(intent.getStringExtra("data"));
			if (rootObj.has("layer")) {
				Layer l = new Layer();
				l.loadJSON(rootObj.getJSONObject("layer"));
				ArrayList<Layer> layers = app.getExperience().getMap().getLayers();
				Layer currL = null;
				boolean found = false;
				int i = 0;
				while ( (i<layers.size()) && (!found) ) {
					currL = layers.get(i);
					if (currL.getId()==l.getId()) {
						found = true;
						layers.set(i, l);
					}
				}
				if (!found) {
					layers.add(l);
				}
			} else {
				if (rootObj.has("map")) {
					Map m = new Map();
					m.loadJSON(rootObj.getJSONObject("map"));
					app.getExperience().setMap(m);
				}
			}
		}
		catch (Exception e) {
			//Log.e(TAG,e.getMessage());
		}
		app.broadcastMapChanging(getBaseContext(), false);
	}

}
