/**
 * 
 */
package uoc.tfc.gien.entities;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import uoc.tfc.gien.R.drawable;
import uoc.tfc.gien.entities.GieInfo;
import uoc.tfc.gien.storage.Storage;
import uoc.tfc.gien.R;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class GieListItem {

	private File directory;
	private String name;
	private String description;
	private Bitmap favicon;
	
	/**
	 * 
	 * @param directory - directory containing the gie
	 */
	public GieListItem(File directory, Resources res) throws FileNotFoundException, IOException {
		setDirectory(directory);
		String infoJsonContent = Storage.getInfoJsonContent(directory);
		String[] nAndD = GieInfo.getNameAndDescription(infoJsonContent);
		setName(nAndD[0]);
		setDescription(nAndD[1]);
		//load image
		String faviconPath = directory.toString()+File.separator+"favicon.png";
		File faviconFile = new File(faviconPath);
		if (faviconFile.exists()) {
			favicon = BitmapFactory.decodeFile(faviconPath);
		} else {
			favicon = BitmapFactory.decodeResource(res, R.drawable.ic_launcher);
		}
		
	}
	
	/**
	 * @return the directory
	 */
	public File getDirectory() {
		return directory;
	}

	/**
	 * @param directory the directory to set
	 */
	public void setDirectory(File directory) {
		this.directory = directory;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the favicon
	 */
	public Bitmap getFavicon() {
		return favicon;
	}

	/**
	 * @param favicon the favicon to set
	 */
	public void setFavicon(Bitmap favicon) {
		this.favicon = favicon;
	}

}
