/**
 *
 */
package uoc.tfc.gien.entities.geo;

import org.json.JSONObject;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class GPSPosition {

	private double latitude;
	private double longitude;
	private double altitude;

	/**
	 * Constructor
	 */
	public GPSPosition() {
		//TO DO
	}
	
	/**
	 * Constructor
	 * 
	 * @param latitude
	 * @param longitude
	 * @param altitude
	 */
	public GPSPosition(double latitude, double longitude, double altitude) {
		this.setLatitude(latitude);
		this.setLongitude(longitude);
		this.setAltitude(altitude);
	}

	/**
	 * @return the latitude
	 */
	public synchronized double getLatitude() {
		return latitude;
	}

	/**
	 * @param latitude the latitude to set
	 */
	public synchronized void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	/**
	 * @return the longitude
	 */
	public synchronized double getLongitude() {
		return longitude;
	}

	/**
	 * @param longitude the longitude to set
	 */
	public synchronized void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	/**
	 * @return the altitude
	 */
	public synchronized double getAltitude() {
		return altitude;
	}

	/**
	 * @param altitude the altitude to set
	 */
	public synchronized void setAltitude(double altitude) {
		this.altitude = altitude;
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		try {
			this.setAltitude(object.getDouble("altitude"));
			this.setLatitude(object.getDouble("latitude"));
			this.setLongitude(object.getDouble("longitude"));
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

}
