/**
 *
 */
package uoc.tfc.gien.entities.geo;

import org.json.JSONObject;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public abstract class GeoObject {
	
	public enum Type {
		SINGLE_POINT, MULTI_POINT, ROUTE, POLYGON;
	}
	
	private boolean visibility;
	private int id;
	private String name;
	private String description;
	private int selectId;
	private boolean visited;
	private Type type;

	/**
	 * Constructor
	 */
	public GeoObject() {
		//TO DO
	}
	
	/**
	 * Constructor
	 * 
	 * @param id
	 * @param name
	 * @param description
	 * @param visibility
	 * @param select
	 * @param visited
	 */
	public GeoObject(int id, String name, String description, boolean visibility, int selectId, boolean visited) {
		this.setId(id);
		this.setName(name);
		this.setDescription(description);
		this.setVisibility(visibility);
		this.setSelectId(selectId);
		this.setVisited(visited);
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON (JSONObject object) {
		try {
			this.setId(object.getInt("id"));
			this.setName(object.getString("name"));
			this.setDescription(object.getString("description"));
			this.setVisibility(object.getBoolean("visibility"));
			this.setSelectId(object.optInt("selectid"));
			this.setVisited(object.getBoolean("visited"));
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

	/**
	 * @return the visibility
	 */
	public boolean isVisible() {
		return visibility;
	}

	/**
	 * @param visibility the visibility to set
	 */
	public void setVisibility(boolean visibility) {
		this.visibility = visibility;
	}

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the selectId
	 */
	public int getSelectId() {
		return selectId;
	}

	/**
	 * @param select the select to set
	 */
	public void setSelectId(int selectId) {
		this.selectId = selectId;
	}

	/**
	 * @return the visited
	 */
	public boolean isVisited() {
		return visited;
	}

	/**
	 * @param visited the visited to set
	 */
	public void setVisited(boolean visited) {
		this.visited = visited;
	}

	/**
	 * @return the type
	 */
	public Type getType() {
		return type;
	}

	/**
	 * @param type the type to set
	 */
	public void setType(Type type) {
		this.type = type;
	}

}
