/**
 * 
 */
package uoc.tfc.gien.entities.geo;

import java.util.ArrayList;

import org.json.JSONObject;


/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class Route extends MultiPointObject {

	private int color; //32bit ARGB .color(0xffff0000)
	private int width;
	
	/**
	 * Constructor
	 */
	public Route() {
		super();
		this.setType(Type.ROUTE);
	}

	/**
	 * Constructor
	 * 
	 * @param id
	 * @param name
	 * @param description
	 * @param visibility
	 * @param select
	 * @param visited
	 * @param points
	 * @param color
	 * @param width
	 */
	public Route(int id, String name, String description, boolean visibility,
			int selectId, boolean visited, ArrayList<SinglePointObject> points, int color, int width) {
		super(id, name, description, visibility, selectId, visited, points);
		this.setColor(color);
		this.setWidth(width);
		this.setType(Type.ROUTE);
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		super.loadJSON(object);
		try {
			this.setColor(object.getInt("color"));
			this.setWidth(object.getInt("width"));
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

	/**
	 * @return the color
	 */
	public int getColor() {
		return color;
	}

	/**
	 * @param color the color to set
	 */
	public void setColor(int color) {
		this.color = color;
	}

	/**
	 * @return the width
	 */
	public int getWidth() {
		return width;
	}

	/**
	 * @param width the width to set
	 */
	public void setWidth(int width) {
		this.width = width;
	}

}
