/**
 * 
 */
package uoc.tfc.gien.entities.interactive;

import java.io.Serializable;

import org.json.JSONObject;

import uoc.tfc.gien.interpreter.Interpreter;
import android.content.Context;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class InventoryObject extends Option implements Usable, Serializable {
	
	private static final long serialVersionUID = 1L;
	
	public enum AvailabilityType {
		
		INFINITE, LIMITED;
		
	}
	
	private AvailabilityType availability;
	private int units;

	/**
	 * Constructor
	 */
	public InventoryObject() {
		super();
	}

	/**
	 * Constructor
	 * 
	 * @param id
	 * @param name
	 * @param description
	 * @param function
	 * @param availability
	 * @param units
	 */
	public InventoryObject(int id, String name, String description,
			String function, AvailabilityType availability, int units) {
		super(id, name, description, function);
		this.setAvailability(availability);
		this.setUnits(units);
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		super.loadJSON(object);
		try {
			this.setAvailability(AvailabilityType.valueOf(object.getString("availability")));
			this.setUnits(object.getInt("units"));
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

	/**
	 * @return the availability
	 */
	public AvailabilityType getAvailability() {
		return availability;
	}

	/**
	 * @param availability the availability to set
	 */
	public void setAvailability(AvailabilityType availability) {
		this.availability = availability;
	}

	/**
	 * @return the units
	 */
	public int getUnits() {
		return units;
	}

	/**
	 * @param units the units to set
	 */
	public void setUnits(int units) {
		this.units = units;
	}
	
}
