/**
 * 
 */
package uoc.tfc.gien.entities.interactive;

import java.io.Serializable;

import org.json.JSONObject;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class Message implements Serializable{

	private static final long serialVersionUID = 1L;

	public enum TextType {
		
		PLAIN_TEXT, HTML;
		
	}
	
	private int id;
	private String title;
	private String text;
	private TextType textType;
	
	/**
	 * Constructor
	 */
	public Message() {
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Constructor
	 * 
	 * @param id
	 * @param title
	 * @param text
	 * @param textType
	 */
	public Message(int id, String title, String text, TextType textType) {
		this.setId(id);
		this.setTitle(title);
		this.setText(text);
		this.setTextType(textType);
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		try {
			this.setId(object.getInt("id"));
			this.setTitle(object.getString("title"));
			this.setText(object.getString("text"));
			this.setTextType(TextType.valueOf(object.getString("texttype")));
		} catch (Exception e) {
			//e.printStackTrace();
			return false;
		}
		return true;
	}

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * @param title the title to set
	 */
	public void setTitle(String title) {
		this.title = title;
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @return the textType
	 */
	public TextType getTextType() {
		return textType;
	}

	/**
	 * @param textType the textType to set
	 */
	public void setTextType(TextType textType) {
		this.textType = textType;
	}
	
}
