/**
 * 
 */
package uoc.tfc.gien.entities.interactive;

import java.io.Serializable;

import org.json.JSONObject;

import uoc.tfc.gien.interpreter.Interpreter;
import android.content.Context;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class Option implements Usable, Serializable {

	private static final long serialVersionUID = 1L;
	private int id;
	private String name;
	private String description;
	private String function;
	
	/**
	 * Constructor
	 */
	public Option() {
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Constructor
	 * 
	 * @param id
	 * @param name
	 * @param description
	 * @param function
	 */
	public Option(int id, String name, String description, String function) {
		this.setId(id);
		this.setName(name);
		this.setDescription(description);
		this.setFunction(function);
	}


	@Override
	public void use(Context context) {
		String function = getFunction();
		if (function!=null) {
			Interpreter.execute(context, function);
		}
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		try {
			this.setId(object.getInt("id"));
			this.setName(object.getString("name"));
			this.setDescription(object.getString("description"));
			this.setFunction(object.optString("function"));
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the function
	 */
	public String getFunction() {
		return function;
	}

	/**
	 * @param function the function to set
	 */
	public void setFunction(String function) {
		this.function = function;
	}

}
