/**
 * 
 */
package uoc.tfc.gien.interpreter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class Function {
	
	private String name;
	private ArrayList<String> params;

	/**
	 * Constructor
	 */
	public Function() {
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Constructor
	 * @param strFunction
	 */
	public Function(String strFunction) {
		fromString(strFunction);
	}
	
	/**
	 * Gets the name of the function
	 * 
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set the name of the function
	 * 
	 * @param name - the name to be set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Gets the parameters of the function
	 * 
	 * @return the parameters in this function
	 */
	public ArrayList<String> getParams() {
		return params;
	}

	/**
	 * Sets parameters of this function
	 * 
	 * @param params
	 */
	public void setParams(ArrayList<String> params) {
		this.params = params;
	}
	
	/**
	 * Adds a new parameter to the function
	 * 
	 * @param value - the value of the new parameter
	 */
	public void addParam(String param) {
		this.getParams().add(param);
	}
	
	/**
	 * Loads the function from a string representation
	 * @param strFunction
	 */
	public void fromString(String strFunction) {
		
	}
	
	/**
	 * Loads the object properties from a JSONObject
	 * 
	 * @param object - object representing a function
	 * @return true if success, false if not
	 */
	public boolean loadJSON(JSONObject object) {
		try {
			this.setName(object.getString("name"));
			JSONArray jsonParamsArray = object.getJSONArray("params");
			if (jsonParamsArray.length()>0) {
				for(int i=0; i<jsonParamsArray.length();i++) {
					String param = jsonParamsArray.getString(i);
					this.addParam(param);
				}
			}
			return true;
		} catch (Exception e) {
			//Log.e(TAG,e.getMessage());
			return false;
		}
	}

}
