package uoc.tfc.gien.ui;

import java.net.URL;
import java.util.List;

import org.json.JSONObject;

import uoc.tfc.gien.GlobalApplicationData;
import uoc.tfc.gien.R;
import uoc.tfc.gien.communication.Communication;
import uoc.tfc.gien.communication.RESTMethod;
import uoc.tfc.gien.entities.interactive.Option;
import uoc.tfc.gien.ui.listAdapters.OptionAdapter;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.res.Resources;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;

/**
 * 
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class ActionsListActivity extends ListActivity {

	private GlobalApplicationData globalData;
	private List<Option> list;
	private OptionAdapter adapter;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//setContentView(R.layout.activity_select);
		setContentView(R.layout.activity_actions_list);
		globalData = (GlobalApplicationData) getApplicationContext();
		this.list = globalData.getExperience().getActions();
		this.adapter = new OptionAdapter(this,list);
		setListAdapter(adapter);
		dataUpdate();
	}
	
	@Override
	protected void onListItemClick(ListView listView, View view, int position, long id) {
		super.onListItemClick(listView, view, position, id);
		this.list.get(position).use(this);
	}
	
	private void dataUpdate() {
		new UpdateTask(this).execute();
	}
	
	private void updateList() {
		adapter.notifyDataSetChanged();
	}
	
	private class UpdateTask extends AsyncTask<Void, Void, Boolean> {

		private ProgressDialog pd;
		private Context context;
		private Resources resources;
		final GlobalApplicationData app;
		
		
		public UpdateTask(Context context) {
			this.context = context;
			this.context = context;
			resources = context.getResources();
			app = (GlobalApplicationData) context.getApplicationContext();
		}
		
		@Override
		protected void onPreExecute() {
			pd = new ProgressDialog(context);
			pd.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			pd.setCancelable(false);
			pd.setIndeterminate(true);
			pd.show();
	        super.onPreExecute();
		}
		
		@Override
		protected Boolean doInBackground(Void... params) {
			String data = null;
			boolean isLoaded = false;
			
			if (app.isOnlineGie()) {
				try {
					data = Communication.getActions(app.getLocation(),app.getServerUrl());
					JSONObject o = new JSONObject(data);
					isLoaded = app.getExperience().loadJSONOptions(o);
				} catch (Exception e) {
					return false;
				}
				return isLoaded;
			} else {
				// do nothing
				return true;
			}
		}
		
		@Override
		protected void onPostExecute(Boolean success) {
			pd.dismiss();
			if (success) {
				updateList();
			}
		}
	}
	
}
