package uoc.tfc.gien.ui;

import java.net.URL;

import uoc.tfc.gien.GlobalApplicationData;
import uoc.tfc.gien.LoadOnlineGie;
import uoc.tfc.gien.R;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


/**
 * 
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class ConnectToServerActivity extends Activity {

	private EditText txtUrl;
	private EditText txtUsername;
	private EditText txtPassword;
	private Button btnConnect;
	private Button btnFavourites;
	
	private GlobalApplicationData app;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_connect_to_server);
		app = (GlobalApplicationData)getApplicationContext();
		txtUrl = (EditText)findViewById(R.id.urlExperience);
		txtUsername = (EditText)findViewById(R.id.usernameExperience);
		txtPassword = (EditText)findViewById(R.id.passwordExperience);
		btnConnect = (Button)findViewById(R.id.btnConnect);
		btnFavourites = (Button)findViewById(R.id.btnOpenFavourite);
		
		btnConnect.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				try {
					new LoadOnlineGie(ConnectToServerActivity.this).execute(new URL(txtUrl.getText().toString()));
					//new LoadOnlineGie(ConnectToServerActivity.this).execute(txtUrl.getText().toString());
					app.setFromFavorites(false);
				} catch (Exception e) {
					//showDialog(e.getMessage());
					Toast.makeText(ConnectToServerActivity.this, R.string.url_error, Toast.LENGTH_SHORT).show();
				}
			}
		});
		
		btnFavourites.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Intent intent = new Intent(ConnectToServerActivity.this,FavoritesListActivity.class);
				startActivity(intent);
			}
		});
	}
	
}
