package uoc.tfc.gien.ui;

import java.net.URL;

import uoc.tfc.gien.GlobalApplicationData;
import uoc.tfc.gien.R;
import uoc.tfc.gien.database.FavouritesSQLite;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

public class FavoriteActivity extends Activity {

	private boolean edit;
	
	private EditText txtName;
	private EditText txtURL;
	private EditText txtUsername;
	private EditText txtPassword;
	
	private String name;
	private URL url;
	private String username;
	private String password;
	private int id;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_favorite);
		Intent intent = getIntent();
		this.edit = intent.getBooleanExtra("edit", false);
		txtName = (EditText)findViewById(R.id.editTextName);
		txtName.setText(intent.getStringExtra("name"));
		txtURL = (EditText)findViewById(R.id.editTextURL);
		txtURL.setText(intent.getStringExtra("url"));
		txtUsername = (EditText)findViewById(R.id.editTextUsername);
		txtUsername.setText(intent.getStringExtra("username"));
		txtPassword = (EditText)findViewById(R.id.editTextPassword);
		txtPassword.setText(intent.getStringExtra("password"));
		id = intent.getIntExtra("id", 0);
	}
	
	public void save(View v) {
		try {
			GlobalApplicationData app = (GlobalApplicationData)getApplicationContext();
			FavouritesSQLite db = app.getFavoritesDatabase();
			if (validateFields()) {
				if (edit) {
					db.updateReg(id, url.toString(), username, password, name);
				} else {
					db.addReg(url.toString(), username, password, name);
					inform(R.string.favorite_saved_successfully);
				}
				finish();
			} else {
				inform(R.string.invalid_fields);
			}
		} catch (Exception e) {
			inform(e.getMessage());
		}
	}
	
	public void discard(View v) {
		finish();
	}
	
	public boolean validateFields() {
		name = txtName.getText().toString().trim();
		String strurl = txtURL.getText().toString().trim();
		if (strurl.substring(0, 7).compareTo("http://")!=0) {
			strurl = "http://"+strurl;
		}
		try {
			url = new URL(strurl);
		}
		catch (Exception e) {
			return false;
		}
		return (name.compareTo("")!=0);
	}
	
	public void inform(String msg) {
		Toast t = Toast.makeText(this, msg, Toast.LENGTH_LONG);
		t.setGravity(Gravity.CENTER_HORIZONTAL|Gravity.CENTER_VERTICAL, 0, 0);
		t.show();
	}
	
	public void inform(int text) {
		Toast t = Toast.makeText(this, text, Toast.LENGTH_LONG);
		t.setGravity(Gravity.CENTER_HORIZONTAL|Gravity.CENTER_VERTICAL, 0, 0);
		t.show();
	}

}
