package uoc.tfc.gien.ui;

import uoc.tfc.gien.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	public void openConnectionDetails(View v) {
		Intent intent = new Intent(this, ConnectToServerActivity.class);
		try {
			startActivity(intent);
		} catch (Exception e) {
			showDialog(e.getMessage());
		}
	}
	
	public void openFavoritesList(View v) {
		Intent intent = new Intent(this, FavoritesListActivity.class);
		try {
			startActivity(intent);
		} catch (Exception e) {
			showDialog(e.getMessage());
		}
	}
	
	public void openOfflineList(View v) {
		Intent intent = new Intent(this, StoredGiesListActivity.class);
		try {
			startActivity(intent);
		} catch (Exception e) {
			showDialog(e.getMessage());
		}
	}
	
	public void openAbout(View v) {
		View view = getLayoutInflater().inflate(R.layout.activity_about, null, false);
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setIcon(R.drawable.ic_launcher)
        	.setTitle(R.string.app_name)
        	.setView(view)
        	.create()
        	.show();
	}
	
	public void openSettings(View v) {
		Intent intent = new Intent(this, PreferencesActivity.class);
		try {
			startActivity(intent);
		} catch (Exception e) {
			showDialog(e.getMessage());
		}
	}
	
	public void exit(View v) {
		finish();
	}
	
	//DEBUG
	public void showDialog(String text) {
		Toast.makeText(this, text, Toast.LENGTH_SHORT).show();
	}
}
