package uoc.tfc.gien.ui;

import uoc.tfc.gien.GlobalApplicationData;
import uoc.tfc.gien.R;
import uoc.tfc.gien.entities.interactive.Select;
import uoc.tfc.gien.ui.listAdapters.SelectAdapter;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class SelectActivity extends ListActivity {

	private Select select;
	private GlobalApplicationData app;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		app = (GlobalApplicationData)this.getApplicationContext();
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_select);
		Intent intent = getIntent();
		this.select = app.getQueuedSelects().get(intent.getIntExtra("id", 0));
		if (select!=null) {
			TextView txtTitle = (TextView)findViewById(R.id.select_title);
			TextView txtText = (TextView)findViewById(R.id.select_text);
			txtTitle.setText(select.getTitle());
			txtText.setText(select.getText());
			setListAdapter(new SelectAdapter(this,select.getItems()));
		} else {
			finish();
			Toast.makeText(this, R.string.error_retrieving_information, Toast.LENGTH_SHORT).show();
		}
	}
	
	@Override
	protected void onListItemClick(ListView listView, View view, int position, long id) {
		super.onListItemClick(listView, view, position, id);
		select.getItems().get(position).use(this);
		finish();
	}
	
	@Override
	protected void onDestroy() {
		super.onDestroy();
		if ((isFinishing()) && (select!=null)) {
			app.getQueuedSelects().remove(select.getId());
		}
	}
	
}
