package uoc.tfc.gien.ui;

import uoc.tfc.gien.LoadOfflineGie;
import uoc.tfc.gien.R;
import uoc.tfc.gien.entities.GieListItem;
import uoc.tfc.gien.storage.Storage;
import uoc.tfc.gien.ui.listAdapters.GieAdapter;
import android.app.ListActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ListView;

/**
 * 
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class StoredGiesListActivity extends ListActivity {
	
	final String TAG = "StoredGiesListActivity";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_stored_gies_list);
		try {
			setListAdapter(new GieAdapter(this, Storage.getPublicGies(this.getResources())));
		} catch (Exception e){
			Log.e(TAG,e.getMessage());
		}
	}
	
	@Override
	protected void onListItemClick(ListView listView, View view, int position, long id) {
		super.onListItemClick(listView, view, position, id);
		Object o = getListAdapter().getItem(position);
		try {
			new LoadOfflineGie(this).execute(((GieListItem)o).getDirectory());
		} catch (Exception e) {
			Log.e(TAG,e.getMessage());
		}
	}

}
