/**
 * 
 */
package uoc.tfc.gien.ui.listAdapters;

import java.util.Vector;

import uoc.tfc.gien.R;
import uoc.tfc.gien.entities.Favorite;
import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class FavouriteAdapter extends BaseAdapter {

	private final Activity activity;
	private final Vector<Favorite> list;
	
	public FavouriteAdapter(Activity activity, Vector<Favorite> list) {
		super();
		this.activity = activity;
		this.list = list;
	}
	
	public void refresh(Vector<Favorite> updList) {
		this.list.clear();
		this.list.addAll(updList);
		this.notifyDataSetChanged();
	}
	
	@Override
	public int getCount() {
		return list.size();
	}

	@Override
	public Object getItem(int position) {
		return list.elementAt(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = activity.getLayoutInflater();
		View view = inflater.inflate(R.layout.favourite_row_layout, null, true);
		TextView name = (TextView)view.findViewById(R.id.name);
		name.setText(list.elementAt(position).getName());
		TextView url = (TextView)view.findViewById(R.id.url);
		url.setText(list.elementAt(position).getUrl().toString());
		return view;
	}
	

}
