/**
 * 
 */
package uoc.tfc.gien.ui.listAdapters;

import java.util.Vector;

import uoc.tfc.gien.R;
import uoc.tfc.gien.entities.GieListItem;
import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class GieAdapter extends BaseAdapter {
	
	private final Activity activity;
	private final Vector<GieListItem> list;

	public GieAdapter(Activity activity, Vector<GieListItem> list) {
		super();
		this.activity = activity;
		this.list = list;
	}

	@Override
	public int getCount() {
		return list.size();
	}

	@Override
	public Object getItem(int position) {
		return list.elementAt(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = activity.getLayoutInflater();
		View view = inflater.inflate(R.layout.stored_gie_row_layout, null, true);
		TextView name = (TextView)view.findViewById(R.id.name);
		name.setText(list.elementAt(position).getName());
		TextView description = (TextView)view.findViewById(R.id.description);
		description.setText(list.elementAt(position).getDescription());
		ImageView icon = (ImageView)view.findViewById(R.id.icon);
		icon.setImageBitmap(list.elementAt(position).getFavicon());
		return view;
	}

}
