/**
 * 
 */
package uoc.tfc.gien.ui.listAdapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

import uoc.tfc.gien.R;
import uoc.tfc.gien.entities.interactive.Option;

/**
 * @author Jordi Pérez Sandonís (jordiperez@uoc.edu)
 *
 */
public class OptionAdapter extends BaseAdapter {

	private final Activity activity;
	private final List<Option> list;
	
	/**
	 * Constructor
	 * 
	 * @param activity
	 * @param list
	 */
	public OptionAdapter(Activity activity, List<Option> list) {
		super();
		this.activity = activity;
		this.list = list;
	}
	
	@Override
	public int getCount() {
		return list.size();
	}

	@Override
	public Object getItem(int position) {
		return list.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = activity.getLayoutInflater();
		View view = inflater.inflate(R.layout.action_row_layout, null, true);
		TextView name = (TextView)view.findViewById(R.id.name);
		TextView description = (TextView)view.findViewById(R.id.description);
		ImageView image = (ImageView)view.findViewById(R.id.icon);
		Option o = list.get(position);
		name.setText(o.getName());
		description.setText(o.getDescription());
		image.setImageResource(R.drawable.ic_hand);
		return view;		 
	}

}
